api/urls.py
from django.urls import path

from . import views
from graphs import views as graph_views


app_name = 'api'
urlpatterns = [
    path('datasets', views.dataset_list, name='dataset-list'),
    path('dataset/<slug>', views.dataset_detail, name='dataset-detail'),
    path('dataset/<slug>/<tablename>/data', views.dataset_data, name='dataset-table-data'),
    path('especiais/grafo/sociedades', graph_views.GetResourceNetworkView.as_view(), name='resource-graph'),
    path('especiais/grafo/sociedades/caminhos', graph_views.GetPartnershipPathsView.as_view(), name='partnership-paths'),
    path('especiais/grafo/sociedades/subsequentes', graph_views.GetCompanySubsequentPartnershipsGraphView.as_view(), name='subsequent-partnerships'),
    path('especiais/grafo/sociedades/empresas-mae', graph_views.CNPJCompanyGroupsView.as_view(), name='company-groups'),
    path('especiais/grafo/no', graph_views.GetNodeDataView.as_view(), name='node-data'),
]

brasilio/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/', include('api.urls', namespace='api')),
    path('auth/', include('brasilio_auth.urls', namespace='brasilio_auth')),
    path('', include('core.urls', namespace='core')),
]

brasilio_auth/urls.py
from django.urls import reverse_lazy
from django.contrib.auth import views as auth_views
from django.urls import path

from brasilio_auth.views import CreateUserView


views_config = {
    'login': auth_views.LoginView.as_view(template_name='brasilio_auth/login.html'),
    'logout': auth_views.LogoutView.as_view(),
    'password_reset': auth_views.PasswordResetView.as_view(
        template_name='brasilio_auth/password_reset.html',
        success_url=reverse_lazy('brasilio_auth:password_reset_done'),
        email_template_name='brasilio_auth/emails/password_reset_email.html',
        subject_template_name='brasilio_auth/emails/password_reset_subject.txt',
    ),
    'password_reset_done': auth_views.PasswordResetDoneView.as_view(
        template_name='brasilio_auth/password_reset_done.html',
    ),
    'password_reset_confirm': auth_views.PasswordResetConfirmView.as_view(
        template_name='brasilio_auth/password_reset_form.html',
        success_url=reverse_lazy('brasilio_auth:password_reset_complete'),
    ),
    'password_reset_complete': auth_views.PasswordResetCompleteView.as_view(
        template_name='brasilio_auth/password_reset_complete.html',
    ),
}

app_name = 'brasilio_auth'
urlpatterns = (
    path('login/', views_config['login'], name='login'),
    path('logout/', views_config['logout'], name='logout'),
    path('troca-senha/', views_config['password_reset'], name='password_reset'),
    path('troca-senha/enviada/', views_config['password_reset_done'], name='password_reset_done'),
    path('troca-senha/<uidb64>/<token>/', views_config['password_reset_confirm'], name='password_reset_confirm'),
    path('troca-senha/atualizada/', views_config['password_reset_complete'], name='password_reset_complete'),
    path('logout/', views_config['logout'], name='logout'),
    path('entrar/', CreateUserView.as_view(), name='sign_up'),
)

core/urls.py
from django.urls import path, reverse_lazy
from django.contrib.auth.decorators import login_required

from . import views, views_special

sign_up_url = reverse_lazy('brasilio_auth:sign_up')


app_name = 'core'
urlpatterns = [
    # Institutional pages
    path('', views.index, name='index'),
    path('contato', views.contact, name='contact'),
    path('datasets', views.dataset_list, name='dataset-list'),
    path('home', views.home, name='home'),
    path('dataset/<slug>', views.dataset_detail, name='dataset-detail'),
    path('dataset/<slug>/<tablename>', views.dataset_detail, name='dataset-table-detail'),
    path('datasets/sugira', views.dataset_suggestion, name='dataset-suggestion'),
    path('manifesto', views.manifesto, name='manifesto'),
    path('colabore', views.collaborate, name='collaborate'),
    path('doe', views.donate, name='donate'),

    # Dataset-specific pages (specials)
    path('especiais', views_special.index, name='specials'),
    path('especiais/documento/<document>', login_required(views_special.document_detail, login_url=sign_up_url), name='special-document-detail'),
    path('especiais/caminho', login_required(views_special.trace_path, login_url=sign_up_url), name='special-trace-path'),
    path('especiais/grupos', login_required(views_special.company_groups, login_url=sign_up_url), name='special-company-groups'),
]

core/models.py
import hashlib
from textwrap import dedent
from urllib.parse import urlparse

import django.db.models.indexes as django_indexes
from django.contrib.postgres.fields import ArrayField, JSONField
import django.contrib.postgres.indexes as pg_indexes
from django.contrib.postgres.search import (SearchQuery, SearchVector,
                                            SearchVectorField)
from django.db import connection, models


DYNAMIC_MODEL_REGISTRY = {}
FIELD_TYPES = {
    'binary': models.BinaryField,
    'bool': models.BooleanField,
    'date': models.DateField,
    'datetime': models.DateTimeField,
    'decimal': models.DecimalField,
    'email': models.EmailField,
    'float': models.FloatField,
    'integer': models.IntegerField,
    'json': JSONField,
    'string': models.CharField,
    'text': models.TextField,
}

def model_to_code(Model):
    meta = Model._meta
    extra = Model.extra
    model_name = Model.__name__
    ordering = extra.get('ordering', [])
    filtering = extra.get('filtering', [])
    search = extra.get('search', [])
    indexes = ',\n                    '.join(
        f'models.{index.__class__.__name__}(name={repr(index.name)}, fields={repr(index.fields)})'
        for index in meta.indexes
    )
    fields_text = []
    for field in meta.fields:
        if field.name == 'id':
            continue
        field_type = field.__class__.__name__.replace('Field', '').lower()
        if field_type == 'searchvector':
            field_class = 'SearchVector'
        elif field_type == 'jsonfield':
            field_class = 'JSONField'
        else:
            if field_type == 'char':
                field_type = 'string'
            field_class = 'models.' + FIELD_TYPES[field_type].__name__
        kwargs = {
            'null': field.null,
        }
        options = 'max_length max_digits decimal_places'.split()
        for option in options:
            value = getattr(field, option, None)
            if value:
                kwargs[option] = value
        field_args = ', '.join(
            '{}={}'.format(key, repr(value)) for key, value in kwargs.items()
        )
        fields_text.append(
            f'{field.name} = {field_class}({field_args})'
        )

    fields = '\n            '.join(fields_text)
    # TODO: missing objects?
    return dedent(f'''
        class {model_name}(models.Model):

            {fields}

            class Meta:
                indexes = [
                    {indexes}
                ]
                ordering = {repr(ordering)}
    ''').strip()

def make_index_name(tablename, index_type, fields):
    idx_hash = hashlib.md5(
        f'{tablename} {index_type} {", ".join(sorted(fields))}'.encode('ascii')
    ).hexdigest()
    tablename = tablename.replace('data_', '').replace('-', '')[:12]
    return f'idx_{tablename}_{index_type[0]}{idx_hash[-12:]}'


class DynamicModelMixin:

    @classmethod
    def tablename(cls):
        return cls._meta.db_table

    @classmethod
    def create_table(cls, create_indexes=True):
        indexes = cls._meta.indexes
        if not create_indexes:
            cls._meta.indexes = []
        try:
            with connection.schema_editor() as schema_editor:
                schema_editor.create_model(cls)
        except:
            raise
        finally:
            # TODO: check if this approach really works - it looks like Django
            # is caching something so the model class must be recreated - see
            # Table.get_model comments.
            cls._meta.indexes = indexes

    @classmethod
    def analyse_table(cls):
        with connection.cursor() as cursor:
            cursor.execute('VACUUM ANALYSE {}'.format(cls.tablename()))

    @classmethod
    def create_triggers(cls):
        trigger_name = f'tgr_tsv_{cls.tablename()}'
        fieldnames = ', '.join(cls.extra['search'])
        query = dedent(f'''
            CREATE TRIGGER {trigger_name}
                BEFORE INSERT OR UPDATE
                ON {cls.tablename()}
                FOR EACH ROW EXECUTE PROCEDURE
                tsvector_update_trigger(search_data, 'pg_catalog.portuguese', {fieldnames})
        ''').strip()
        # TODO: replace pg_catalog.portuguese with dataset language
        with connection.cursor() as cursor:
            cursor.execute(query)

    @classmethod
    def create_indexes(cls):
        with connection.cursor() as cursor:
            for index in cls._meta.indexes:
                index_class = type(index)
                if index_class is django_indexes.Index:
                    index_type = 'btree'
                elif index_class is pg_indexes.GinIndex:
                    index_type = 'gin'
                else:
                    raise ValueError('Cannot identify index type of {index}')

                fieldnames = []
                for fieldname in index.fields:
                    if fieldname.startswith('-'):
                        value = f'{fieldname[1:]} DESC'
                    else:
                        value = f'{fieldname} ASC'
                    if index_type == 'gin':
                        value = value.split(' ')[0]
                    fieldnames.append(value)

                fieldnames = ',\n                            '.join(fieldnames)
                query = dedent(f'''
                    CREATE INDEX CONCURRENTLY {index.name}
                        ON {cls.tablename()} USING {index_type} (
                            {fieldnames}
                        );
                ''').strip()
                cursor.execute(query)

    @classmethod
    def delete_table(cls):
        with connection.schema_editor() as schema_editor:
            schema_editor.delete_model(cls)


class DynamicModelQuerySet(models.QuerySet):

    def search(self, search_query):
        qs = self
        search_fields = self.model.extra['search']
        if search_query and search_fields:
            words = search_query.split()
            config = 'pg_catalog.portuguese'  # TODO: get from self.model.extra
            query = None
            for word in set(words):
                if not word:
                    continue
                if query is None:
                    query = SearchQuery(word, config=config)
                else:
                    query = query & SearchQuery(word, config=config)
            qs = qs.filter(search_data=query)
        return qs

    def apply_filters(self, filtering):
        qs = self
        model_filtering = self.model.extra['filtering']
        if model_filtering is not None:
            for field_name in model_filtering:
                value = filtering.get(field_name, None)
                if value is not None:
                    qs = qs.filter(**{field_name: value})
        return qs

    def apply_ordering(self, query):
        qs = self
        model_ordering = self.model.extra['ordering']
        model_filtering = self.model.extra['filtering']
        allowed_fields = set(model_ordering + model_filtering)
        clean_allowed = [field.replace('-', '').strip().lower()
                         for field in allowed_fields]
        ordering_query = [field for field in query
                          if field.replace('-', '') in clean_allowed]
        if ordering_query:
            qs = qs.order_by(*ordering_query)
        elif model_ordering:
            qs = qs.order_by(*model_ordering)

        return qs


    def count(self):
        if getattr(self, '_count', None) is not None:
            return self._count

        query = self.query
        if not query.where:
            try:
                with connection.cursor() as cursor:
                    cursor.execute(
                        "SELECT reltuples FROM pg_class WHERE relname = %s",
                        [query.model._meta.db_table],
                    )
                    self._count = int(cursor.fetchone()[0])
            except:
                self._count = super().count()
        else:
            self._count = super().count()

        return self._count


class Dataset(models.Model):
    author_name = models.CharField(max_length=255, null=False, blank=False)
    author_url = models.URLField(max_length=2000, null=True, blank=True)
    code_url = models.URLField(max_length=2000, null=False, blank=False)
    description = models.TextField(null=False, blank=False)
    icon = models.CharField(max_length=31, null=False, blank=False)
    license_name = models.CharField(max_length=255, null=False, blank=False)
    license_url = models.URLField(max_length=2000, null=False, blank=False)
    name = models.CharField(max_length=255, null=False, blank=False)
    show = models.BooleanField(null=False, blank=False, default=False)
    slug = models.SlugField(max_length=50, null=False, blank=False)
    source_name = models.CharField(max_length=255, null=False, blank=False)
    source_url = models.URLField(max_length=2000, null=False, blank=False)

    @property
    def tables(self):
        # By now we're ignoring version - just take the last one
        version = self.get_last_version()
        return self.table_set.filter(version=version).order_by('name')

    def get_table(self, tablename):
        return Table.objects.for_dataset(self).named(tablename)

    def get_default_table(self):
        return Table.objects.for_dataset(self).default()

    def __str__(self):
        return ('{} (by {}, source: {})'
                .format(self.name, self.author_name, self.source_name))

    def get_model_declaration(self):
        version = self.version_set.order_by('order').last()
        table = self.table_set.get(version=version, default=True)
        return table.get_model_declaration()

    def get_last_version(self):
        return self.version_set.order_by('order').last()


class Link(models.Model):
    dataset = models.ForeignKey(Dataset, on_delete=models.CASCADE,
                                null=False, blank=False)
    title = models.CharField(max_length=255, null=False, blank=False)

core/forms.py
from django import forms
from django.core.exceptions import ObjectDoesNotExist

from core.models import Dataset
from core.util import get_company_by_document


def _resolve_field_by_type(person_type):
    if person_type == 'pessoa-fisica':
        return 'nome_socio'
    elif person_type == 'pessoa-juridica':
        return 'cnpj'


def _get_obj(field, identifier, person_type):
    if person_type == 'pessoa-fisica':
        Socios = Dataset.objects.get(slug='socios-brasil')\
                                .get_table('socios')\
                                .get_model()
        return Socios.objects.filter(**{field: identifier}).first()
    elif person_type == 'pessoa-juridica':
        try:
            return get_company_by_document(identifier)
        except ObjectDoesNotExist:
            return None


def _get_name(obj, person_type):
    if person_type == 'pessoa-fisica':
        return obj.nome_socio
    elif person_type == 'pessoa-juridica':
        return obj.name


class TracePathForm(forms.Form):
    TYPE_CHOICES = [
        ('pessoa-fisica', 'Pessoa Física (nome completo)'),
        ('pessoa-juridica', 'Pessoa Jurídica (CNPJ)')
    ]

    origin_type = forms.ChoiceField(choices=TYPE_CHOICES, required=True)
    origin_identifier = forms.CharField(required=True)

    destination_type = forms.ChoiceField(choices=TYPE_CHOICES, required=True)
    destination_identifier = forms.CharField(required=True)

    def clean(self):
        cleaned_data = super().clean()
        origin_type = cleaned_data.get('origin_type')
        origin_identifier = cleaned_data.get('origin_identifier')
        destination_type = cleaned_data.get('destination_type')
        destination_identifier = cleaned_data.get('destination_identifier')


        origin_field = _resolve_field_by_type(origin_type)
        destination_field = _resolve_field_by_type(destination_type)
        origin = _get_obj(origin_field, origin_identifier, origin_type)
        destination = _get_obj(destination_field, destination_identifier, destination_type)

        if origin is None:
            self.add_error('origin_identifier', 'Name/document not found')
        else:
            cleaned_data['origin_name'] = _get_name(origin, origin_type)
        if destination is None:
            self.add_error('destination_identifier', 'Name/document not found')
        else:
            cleaned_data['destination_name'] = _get_name(destination, destination_type)

        return cleaned_data


class CompanyGroupsForm(forms.Form):
    identifier = forms.CharField(required=True, label='CNPJ')

    def clean(self):
        cleaned_data = super().clean()
        identifier = cleaned_data['identifier']
        for char in './-':
            identifier = identifier.replace(char, '')
        company = _get_obj('', identifier, 'pessoa-juridica')
        if not company:
            self.add_error('identifier', 'Document not found')
        else:
            cleaned_data['company'] = company
        return cleaned_data

core/templates/collaborate.html
{% extends 'base.html' %}
{% block title %}Colabore - Brasil.IO{% endblock %}
{% block content %}
<div class="section">
  <h4>Colabore</h4>
  <div class="divider"></div>

  <p>
    Que bom que você se interessou em colaborar com o projeto! :) Existem
    algumas maneiras possíveis:
  </p>

  <h5>Tecnicamente</h5>
  <p>
    Desenvolver e manter a plataforma e novos scripts de libertação de dados é
    de suma importância para que o projeto seja bem sucedido. <a
      href="https://chat.brasil.io/">Entre em nosso chat</a> para conversarmos
    sobre a melhor maneira de colaborar.
  </p>
  <ol>
    <li>
      Utilizando e citando os dados disponíveis no site;
    </li>
    <li>
      <a href="{% url 'core:dataset-suggestion' %}">Sugerindo um novo dataset</a> para libertarmos;
    </li>
    <li>
      Libertando dados e o código do software.
    </li>
  </ol>

  <h5>Financeiramente</h5>
  <p>
    Possuímos diversos gastos para manter o site online e desenvolver novas
    funcionalidades e você pode também contribuir para a sustentabilidade
    financeira do projeto. Se tiver interesse,
    <a href="{% url 'core:contact' %}">entre em contato</a>.
  </p>
  <ol>
    <li>
      Encomendando a libertação de um novo dataset;
    </li>
    <li>
      Encomendando análises e visualizações complexas nos dados que já temos
      disponíveis;
    </li>
    <li>
      <a href="{% url 'core:donate' %}"><b>Doando recorrentemente</b></a>.
    </li>
  </ol>

</div>
{% endblock %}

core/templates/contas-gratuitas.html
<div class="col s12 m12">
  <div class="card horizontal">
    <div class="card-stacked">
      <div class="card-content">
        <div class="card-title">
          <i class="material-icons">info</i>
          Acesso a Páginas Especiais
        </div>
        <p>
          As <a href="{% url 'core:specials' %}">páginas especiais</a> são restritas
          a quem possui uma conta no <a
            href="https://brasil.io/">Brasil.IO</a>. <b>Durante nossa fase BETA
            as contas serão todas gratuitas</b> - após esse período será
          necessária a assinatura do site para acessar todas as páginas
          restritas.
        </p>
        <p>
          O <a href="https://brasil.io/">Brasil.IO</a> é desenvolvido de
          maneira colaborativa e voluntária. <b>Você pode contribuir</b> <a
            href="{% url 'core:donate' %}">fazendo uma doação</a> ou <a
            href="{% url 'core:collaborate' %}">de outras formas</a>.
        </p>
      </div>
    </div>
  </div>
</div>

core/templates/dataset-detail.html
{% extends 'base.html' %}
{% load humanize %}
{% load l10n %}
{% load utils %}
{% block title %}{{ dataset.name }} - Datasets - Brasil.IO{% endblock %}
{% block content %}{% localize off %}
<div class="section">
  <div id="dataset-detail">
    <h4>{{ dataset.name }}</h4>
    <p>
      {{ dataset.description }}
    </p>
    <ul>
      <li>
        Fonte original: <a href="{{ dataset.source_url }}">{{ dataset.source_name }}</a>
      </li>
      <li>
        Libertado por: <a href="{{ dataset.author_url }}">{{ dataset.author_name }}</a>
      </li>
      <li>
        Código-fonte: <a href="{{ dataset.code_url }}">{{ dataset.code_url }}</a>
      </li>
      <li>
        Licença: <a href="{{ dataset.license_url }}">{{ dataset.license_name }}</a>
      </li>
      {% if dataset.link_set.all %}
      <li>
        Links relacionados:
        {% for link in dataset.link_set.all %}
          <a href="{{ link.url }}" target="_blank">{{ link.title }}</a>{% if not forloop.last %}, {% endif %}
        {% endfor %}
      </li>
      {% endif %}
    </ul>
  </div>

  <div class="row">
    <div class="col s12">
      Tabelas:
      {% for dataset_table in dataset.tables %}
        {% spaceless %}
        {% if dataset_table == table %}
        <strong>{{ dataset_table.name }}</strong>
        {% else %}
        <a href="{% url 'core:dataset-table-detail' dataset.slug dataset_table.name %}">{{ dataset_table.name }}</a>
        {% endif %}
        {% endspaceless %}{% if not forloop.last %}, {% else %}.{% endif %}
      {% endfor %}

      <ul class="tabs tabs-fixed-width" id="tabs">
        <li class="tab col s3"><a class="active" href="#data">Dados</a></li>
        <li class="tab col s3"><a href="#metadata">Metadados</a></li>
      </ul>
    </div>
    <div id="data" class="col s12">
      <div class="row">
        <div class="col s12 m12">
          <h5>Filtros</h5>

          <form method="get">
            <div class="row">

              <div class="input-field col s6">
                <label class="active" for="search">Busca</label>
                <input type="text" id="search" name="search" value="{{ search_query|default:'' }}">
              </div>

              {% for field in fields %}
              {% if field.frontend_filter %}{% with value=query_dict|getplainattribute:field|default:'' %}
              <div class="input-field col s6">
                <label class="active" for="{{ field.name }}">{{ field.title }}</label>
              {% if field.has_choices %}
                <select name="{{ field.name }}">
                  <option value="" {% if value == "" %} selected{% endif %}>Todos</option>
                  {% for choice in field.choices.data %}
                  <option value="{{ choice }}"{% if value == choice %} selected{% endif %}>{% if choice == 'None' %}(vazio){% else %}{{ choice }}{% endif %}</option>
                  {% endfor %}
                </select>
                {% else %}
                <input type="text" name="{{ field.name }}" value="{{ value }}">
              {% endif %}
              </div>
            {% endwith %}{% endif %}
            {% endfor %}

            </div>
            <div class="row">
              <input class="btn" type="submit" value="Filtrar">
            </div>

          </form>
        </div>
      </div>

      <div class="row">
        <p> Última atualização: {{ table.last_update }} </p>

        {% if total_count > 0 and total_count <= max_export_rows %}
        <div class="col s12 m7 left" style="padding-left: 0px;">
          <a class="btn" href="{% url 'core:dataset-table-detail' slug table.name %}?{% if querystring %}{{ querystring }}&amp;{% endif %}format=csv">
          {% if querystring %}
            Baixar resultado em CSV
          {% else %}
            Baixar dados em CSV
          {% endif %}
          </a>
        </div>
        {% endif %}

        <div class="col s12 m5 right">
          <ul class="pagination right">
             <li> {{ data.start_index|localize }}-{{ data.end_index|localize }} de um total de {{ total_count|localize }}</li>
            {% if data.has_previous %}
            <li> <a href="?{% if querystring %}{{ querystring }}&amp;{% endif %}page={{ data.previous_page_number }}"><i class="material-icons">chevron_left</i></a> </li>
            {% endif %}

            {% if data.has_next %}
            <li> <a href="?{% if querystring %}{{ querystring }}&amp;{% endif %}page={{ data.next_page_number }}"><i class="material-icons">chevron_right</i></a> </li>
            {% endif %}
          </ul>
        </div>

      </div>

      <div class="row table-container" style="padding-left: 0px;">
        {% with table_id=dataset.slug %}
        {% include 'data-table.html' %}
        {% endwith %}
      </div>
      <p>
        Você também pode <a href="{{ version.download_url }}">baixar o dataset completo</a> ou
        <a href="{% url 'api:dataset-detail' dataset.slug %}">utilizar nossa API</a>.
      </p>

    </div>
    <div id="metadata" class="col s12">

      <div class="row">
        <div class="card horizontal">
          <div class="card-stacked">
            <div class="card-content">
              <span class="card-title activator grey-text text-darken-4">
                Dicionário de Dados - Tabela {{ table.name }}
              </span>

              <table>
                <thead>
                  <tr>
                    <th>Nome da Coluna</th>
                    <th>Descrição</th>
                    <th>Tipo</th>
                  </tr>
                </thead>

                <tbody>
                  {% for field in table.fields %}
                  <tr>
                    <td> {{ field.name }} </td>
                    <td> {{ field.title }} </td>
                    <td> {{ field.type }}{% if field.options_text %} ({{ field.options_text }}){% endif %}</td>
                  </tr>
                  {% endfor %}
                </tbody>

              </table>

            </div>
          </div>
        </div>
      </div>

    </div>

  </div>
</div>
{% endlocalize %}{% endblock %}

{% block script %}
{{ block.super }}
<script type="text/javascript" language="javascript" src="https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js"></script>
<script type="text/javascript">
  $(document).ready(function() {
    M.Tabs.init(document.getElementById('tabs'));
    $('select').formSelect();

    $('.mdl-data-table').DataTable({
        "paging":         false,
        "searching":      false,
        "ordering":       false,
        "bInfo":          false,
    });
  });
</script>
{% endblock %}

core/templates/home.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Home - Brasil.IO{% endblock %}
{% block top %}
<div class="top-container indigo darken-1">
  <div class="container">
    <div class="section indigo-text text-lighten-5">
      <h3>O Brasil em dados libertos</h3>
      <p class="flow-text">Repositório de dados públicos disponibilizados em formato acessível</p>
    </div>
  </div>
</div>
{% endblock %}

{% block content %}
<div class="row">

  <section id="info">
    <div class="row">
      <div class="col s12 m3">
        <div class="card">
          <div class="card-content teal-text">
            <span class="card-title">Manifesto</span>
          </div>
          <div class="card-content card-body">
            <p>Venha entender o que motivou a criação do <strong>Brasil.IO</strong> e quais são os objetivos do projeto!</p>
          </div>
          <div class="card-action">
            <a href="{% url 'core:manifesto' %}">Ver mais</a>
          </div>
        </div>
      </div>

      <div class="col s12 m3">
        <div class="card">
          <div class="card-content teal-text">
            <span class="card-title">Datasets</span>
          </div>
          <div class="card-content card-body">
            <p>Confira a lista completa de todas as base de dados liberadas. </p>
          </div>
          <div class="card-action">
            <a href="{% url 'core:dataset-list' %}">Ver mais</a>
          </div>
        </div>
      </div>

      <div class="col s12 m3">
        <div class="card">
          <div class="card-content teal-text">
            <span class="card-title">Sugira um Dataset</span>
          </div>
          <div class="card-content card-body">
            <p>Conhece algum dataset bacana que gostaria de ver aqui? Sugira para nós! =)</p>
          </div>
          <div class="card-action">
            <a href="{% url 'core:dataset-suggestion' %}">Ver mais</a>
          </div>
        </div>
      </div>

      <div class="col s12 m3">
        <div class="card">
          <div class="card-content teal-text">
            <span class="card-title">Colabore</span>
          </div>
          <div class="card-content card-body">
            <p>Achou o projeto legal e quer contribuir? Veja aqui como. </p>
          </div>
          <div class="card-action">
            <a href="https://github.com/turicas/brasil.io/issues">Ver mais</a>
          </div>
        </div>
      </div>
    </div>
  </section>

  <section id="datasets">
    <div class="divider-new pt-3">
      <h4 class="text-center m-15 dark-blue">Datasets</h4>
    </div>

    {% for dataset in datasets %}
      {% include 'dataset-card.html' %}
    {% endfor %}

    <div class="row text-center">
      <a class="btn btn-ptc btn-md waves-effect waves-light" href="{% url 'core:dataset-list' %}" role="button">
        Ver Todos Datasets
        <i class="fa fa-photo ml-2"></i>
      </a>
    <div>
  </section>

</div>



</div>
{% endblock %}

core/templates/menu.html
{% if request.user.is_authenticated %}
<li>Olá, {{ request.user.username }}</li>
<li><a href="{% url 'brasilio_auth:logout' %}">Logout</a></li>
{% else %}
<li><a href="{% url 'brasilio_auth:sign_up' %}">Cadastre-se</a></li>
<li><a href="{% url 'brasilio_auth:login' %}">Login</a></li>
{% endif %}
<li><a href="{% url 'core:manifesto' %}">Manifesto</a></li>
<li><a href="{% url 'core:dataset-list' %}">Datasets</a></li>
<li><a href="{% url 'core:specials' %}">Especiais</a></li>
<li><a href="{% url 'api:dataset-list' %}">API</a></li>
<li><a href="{% url 'core:collaborate' %}">Colabore</a></li>
<li><a href="{% url 'core:contact' %}">Contato</a></li>
<li><a class="btn" href="{% url 'core:donate' %}">Doe</a></li>